// Example9: Perspective viewing

#include <windows.h>
#include <GL/glut.h>

//	glFrustum(xLeft, xRight, yBotom, yUp, dNear, dFar);
//	gluLookAt(xe, ye, ze, xref, yref, zref, Vx, Vy, Vz);

GLfloat angle = 0;
GLfloat vertices[][3]= {{-1, -1, -1},	// 0
						{ 1, -1, -1},	// 1
						{ 1,  1, -1},	// 2
						{-1,  1, -1},	// 3
						{-1, -1,  1},	// 4
						{ 1, -1,  1},	// 5
						{ 1,  1,  1},	// 6
						{-1,  1, 1}};	// 7

void polygon(int a, int b, int c, int d)
{
	glBegin(GL_LINE_LOOP);
		glVertex3fv(vertices[a]);
		glVertex3fv(vertices[b]);
		glVertex3fv(vertices[c]);
		glVertex3fv(vertices[d]);
	glEnd();
}

void cube()
{
	polygon(0, 3, 2, 1);
	polygon(2, 3, 7, 6);
	polygon(0, 4, 7, 3);
	polygon(1, 2, 6, 5);
	polygon(4, 5, 6, 7);
	polygon(0, 1, 5, 4);
}


void reshape(int w, int h)
{
	glViewport (0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glFrustum(-w/2, w/2, -h/2, h/2, 200, 800);
	gluLookAt(0, 0, 400, 0, 0, 0, 0, 1, 0);
	glClearColor(1, 1, 1, 0);
	glColor3f(0,0,0);					// set line color to black
	glMatrixMode(GL_MODELVIEW);	
}

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();			
	glScalef(100,100,100);
	glRotatef(angle,0,1,1);
	cube();
	glFlush();
}

void mouse(int button, int state, int x, int y)
{
	switch (button) {
		case GLUT_LEFT_BUTTON:
			if (state == GLUT_DOWN){
				angle += 5;
				angle = (angle >= 360)? 0: angle;
				glutPostRedisplay();
			}
			break;
		
	default:	break;
	}
}


void main()
{
//	glutInit();
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	glutInitWindowPosition(50, 50);
	glutInitWindowSize(400, 400);
	glutCreateWindow("Perspective View of a Cube ");
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);
	glutMainLoop();
}

