// Example8: Rotating a cube in orthograhic projection

#include <windows.h>
#include <GL/glut.h>

GLfloat angle = 0;
GLfloat vertices[][3]= {{-1, -1, -1},	// 0
						{ 1, -1, -1},	// 1
						{ 1,  1, -1},	// 2
						{-1,  1, -1},	// 3
						{-1, -1,  1},	// 4
						{ 1, -1,  1},	// 5
						{ 1,  1,  1},	// 6
						{-1,  1, 1}};	// 7

void polygon(int a, int b, int c, int d)
{
	glBegin(GL_LINE_LOOP);
		glVertex3fv(vertices[a]);
		glVertex3fv(vertices[b]);
		glVertex3fv(vertices[c]);
		glVertex3fv(vertices[d]);
	glEnd();
}

void cube()
{
	glLineWidth(1);
	polygon(0, 3, 2, 1);
	polygon(2, 3, 7, 6);
	polygon(0, 4, 7, 3);
	polygon(1, 2, 6, 5);
	polygon(4, 5, 6, 7);
	polygon(0, 1, 5, 4);
	glLineWidth(2);
	glBegin(GL_LINE_STRIP);
		glVertex3f(-0.5,-0.5, 1);
		glVertex3f(-0.5, 0.5, 1);
		glVertex3f(0.5, -0.5, 1);
		glVertex3f(0.5, 0.5,1);
	glEnd();
}


void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();			
	glScalef(100, 100, 100);
	glRotatef(angle, 0, 1, 1);
	cube();
	glutSwapBuffers(); /* switch the pointers to front and back buffers */ 
	/* glutSwapBuffers does the glFlush for you */ 
}

void reshape(int w, int h)
{
	glViewport (0, 0, (GLsizei) w, (GLsizei) h);
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glOrtho(-w/2, w/2, -h/2, h/2,-h/2, h/2);
	glMatrixMode(GL_MODELVIEW);
}

void idle(void) 
{ 
	static GLint lastTime=0; 
	GLint time = glutGet( GLUT_ELAPSED_TIME ); 	/* increment the angle */ 
	angle += 20.0 * (time - lastTime)/1000; /* 20 degrees per second */

	lastTime = time; 
	glutPostRedisplay(); 
} 


void main(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowPosition(50, 50);
	glutInitWindowSize(400, 400);
	glutCreateWindow("Orthographic View of a Cube ");
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutIdleFunc(idle);
	glutMainLoop();
}

