// Example11: Animation  

#include <windows.h>
#include <GL/glut.h>


GLfloat angle=0;

GLfloat vertices[][3]= {{-1, -1, -1},	// 0
						{ 1, -1, -1},	// 1
						{ 1,  1, -1},	// 2
						{-1,  1, -1},	// 3
						{-1, -1,  1},	// 4
						{ 1, -1,  1},	// 5
						{ 1,  1,  1},	// 6
						{-1,  1, 1}};	// 7

void polygon(int a, int b, int c, int d)
{
	glBegin(GL_QUADS);
		glVertex3fv(vertices[a]);
		glVertex3fv(vertices[b]);
		glVertex3fv(vertices[c]);
		glVertex3fv(vertices[d]);
	glEnd();
}

void cube()
{
	glColor3f(0, 0, 1);
	polygon(0, 3, 2, 1);
	glColor3f(0, 1, 1);
	polygon(2, 3, 7, 6);
	glColor3f(1, 0, 1);
	polygon(0, 4, 7, 3);
	glColor3f(1, 1, 0);
	polygon(1, 2, 6, 5);
	glColor3f(0.1, 0, 1);
	polygon(4, 5, 6, 7);

	polygon(0, 1, 5, 4);
}


void init(void)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-2, 2, -2, 2, -2, 2);
	
	glClearColor(1, 1, 1, 0);
	glColor3f(0,0,0);					// set line color to black
	glMatrixMode(GL_MODELVIEW);
}

void idle(void) 
{ 
	static GLint lastTime=0; 
	GLint time = glutGet( GLUT_ELAPSED_TIME ); 	/* increment the angle */ 
	angle += 20.0 * (time - lastTime)/1000; /* 20 degrees per second */

	lastTime = time; 
	glutPostRedisplay(); 
} 

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	glClear(GL_DEPTH_BUFFER_BIT);   //IMPORTANT
	glLoadIdentity();			

	glRotatef(angle, 0, 1, 1);
	cube();
	glutSwapBuffers(); /* switch the pointers to front and back buffers */ 
	/* glutSwapBuffers does the glFlush for you */ 
}

void main(int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowPosition(50, 50);
	glutInitWindowSize(400, 400);
	glutCreateWindow("Rotating a Cube");
	glEnable(GL_DEPTH_TEST);
	init();
	
	glutDisplayFunc(display);
	glutIdleFunc( idle ); /* register the idle callback */ 
	glDrawBuffer( GL_BACK ); /* draw to the back buffer */ 
	glutMainLoop();
}

